Program Xonix;
Uses Crt,Graph;

type
 coord = record                    { न  ᪮ }
   x,y: integer;                   {   ᫠ }
 end;

 Flying = record                   { ࠬ  }
   DH,DV : Coord;                  { 㤠  砫    }
   StepY, StepX : Integer;         {   ᪮ (饭) }
 end;

 TLine = Object                    {  ᠬ   १ }
       kA1,                        { न ࢮ 窨  (砫) }
       kA2 : coord;                { न ன 窨  () }
       Color   : Integer;          {   }
       procedure Draw;             { 㥬  }
       procedure Hide;             { 祬  }
       procedure Next( Line:TLine; { ᫨ ࠬ ᫥饩  }
                 F:Flying;         {  ᮮ⢥⢨  ࠬࠬ  }
                 Var D:Flying);    {  ᪮४஢ ࠬ }
       procedure ReColor;          {  梥  }
       procedure Let( x1,y1,x2,    {   }
                      y2:integer); {  묨 न⠬ }
 end;

 pXonix = ^XINTREC;
           XINTREC = RECORD        { 㤥 ᯨ᮪  ᨢ }
                   L : TLine;      { 㤠 襬   }
                   PX: pXonix;     {   㤥,   ᫥ }
           End;

  TXonix = Object (TLine)          {   ᪮쪨   XONIX }
         Xo,                       {   ᯨ᮪, ! }
         XoB,                      { 砫 ᯨ᪠ }
         XoE : pXonix;             {  ᯨ᪠ }
         Fly : Flying;             { ࠬ  }
         N : Integer;              { 쪮   XONIX` }
         procedure Draw;           { 㥬 XONIX }
         procedure Move;           {    蠣 XONIX }
         procedure Hide;           {  XONIX }
         procedure Let;            {  XONIX }
  end;

Var
   I : Integer;
   SDelay, SNum, SXon : Integer;
   code : Integer;

   P : Array [1..10] Of TXonix;

   grDriver : Integer;
   grMode   : Integer;

{ -= Line =- }

procedure TLine.Let(x1,y1,x2,y2: integer);
begin
 kA1.x:=x1;
 kA1.y:=y1;
 kA2.x:=x2;
 kA2.y:=y2;
end;

procedure TLine.ReColor;
begin
     Color := Random(15)+1;
end;

Procedure TLine.Next(Line:TLine;F:Flying; Var D:Flying);
  procedure ChangeStep;
  Begin
      F.StepY := Trunc(Random(5))+2;
      F.StepX := Trunc(Random(5))+2;
      {
      F.DH.X := 1-Trunc(Random(3));
      F.DH.Y := 1-Trunc(Random(3));
      F.DV.X := 1-Trunc(Random(3));
      F.DV.Y := 1-Trunc(Random(3));
      }
  End;

Begin
      If (Line.kA1.X + F.StepX * F.DH.X > GetMaxX) Or
         (Line.kA1.X + F.StepX * F.DH.X < 0) Then
         Begin
              F.DH.X := (-1)*F.DH.X;
              ReColor;
              ChangeStep;
         End;

      If (Line.kA1.Y + F.StepY * F.DH.Y > GetMaxY) Or
         (Line.kA1.Y + F.StepY * F.DH.Y < 0) Then
         Begin
              F.DH.Y := (-1)*F.DH.Y;
              ReColor;
              ChangeStep;
         End;

      If (Line.kA2.X + F.StepX * F.DV.X > GetMaxX) Or
         (Line.kA2.X + F.StepX * F.DV.X < 0) Then
         Begin
              F.DV.X := (-1)*F.DV.X;
              ReColor;
              ChangeStep;
         End;

      If (Line.kA2.Y + F.StepY * F.DV.Y > GetMaxY) Or
         (Line.kA2.Y + F.StepY * F.DV.Y < 0) Then
         Begin
              F.DV.Y := (-1)*F.DV.Y;
              ReColor;
              ChangeStep;
         End;

      kA1.X := Line.kA1.X + F.StepX * F.DH.X;
      kA1.Y := Line.kA1.Y + F.StepY * F.DH.Y;
      kA2.X := Line.kA2.X + F.StepX * F.DV.X;
      kA2.Y := Line.kA2.Y + F.StepY * F.DV.Y;

      D:=F;
End;

procedure TLine.Draw;
begin
 SetColor(Color);
 Line(kA1.X, kA1.Y, kA2.X, kA2.Y);
end;

procedure TLine.Hide;
begin
 SetColor(GetBkColor);
 Line(kA1.X, kA1.Y, kA2.X, kA2.Y);
end;


{ -= Xonix =- }

procedure TXonix.Let;
Var I,
    Napr : Integer;
Begin
{-=    ६ =-}
  New(Xo);
  Xo^.L.Let( random(GetMaxX),
             random(GetMaxY),
             random(GetMaxX),
             random(GetMaxY));
  Xo^.L.ReColor;
  Xo^.PX := Nil;
  XoB:=Xo;
  XoE:=Xo;

{-= ࠢ - 砩 =-}
  Napr := random(4);
  Case Napr Of
         0: Begin
                  Fly.DH.X := -1;
                  Fly.DV.X := -1;
                  Fly.DH.Y := 1;
                  Fly.DV.Y := 1;
            End;
         1: Begin
                  Fly.DH.X := 1;
                  Fly.DV.X := 1;
                  Fly.DH.Y := -1;
                  Fly.DV.Y := -1;
            End;
         2: Begin
                  Fly.DH.X := -1;
                  Fly.DV.X := -1;
                  Fly.DH.Y := -1;
                  Fly.DV.Y := -1;
            End;
         3: Begin
                  Fly.DH.X := 1;
                  Fly.DV.X := 1;
                  Fly.DH.Y := 1;
                  Fly.DV.Y := 1;
            End;
  End;

{-=   ⠫ ᪨ ६ =-}
  for i:=2 to N do begin
      New(Xo);
      Xo^.L:=XoE^.L;
      Xo^.L.Next(Xo^.L,Fly,Fly);
      Xo^.PX:=Nil;
      XoE^.PX := Xo;
      XoE := Xo;
  end;
End;

procedure TXonix.Draw;
Var Xon : pXonix;
Begin
{-=  ,  ᮧ =-}
  Xon := XoB;
  While Xon<>Nil Do
  Begin
       Xon^.L.Draw;
       Xon := Xon^.PX;
  End;
End;

procedure TXonix.Move;
Begin
{-----   -------------}
      New(Xo);
      Xo^.L:=XoE^.L;
      Xo^.L.Next(XoE^.L,Fly,Fly);
      Xo^.PX:=Nil;
      XoE^.PX := Xo;
      XoE := Xo;
{----- 뢠 -------------}
      XoE^.L.Draw;
{----- 塞  -------------}
      Xo:=XoB^.PX;
      XoB^.L.Hide;
      Dispose(XoB);
      XoB := Xo;
{------------------}
End;

procedure TXonix.Hide;
Begin
{-= 頥   祬  쥪 =-}
  While XoB<>Nil Do
  Begin
       Xo:=XoB^.PX;
       Xo^.L.Hide;
       Dispose(XoB);
       XoB := Xo;
  End;
End;

Procedure ReadIniFile;
Var F:Text;
    S1,S2:String;
Begin
     SDelay := 10;
     SNum := 10;
     SXon := 10;

     Assign (F,'xon`s.ini');
     ReSet (F);
     While Not(Eof(F)) Do Begin
           ReadLn(F,S1);
           S2 := (Copy(S1,Pos(' ', s1)+1,Length(S1)));
           S1 := (Copy(S1,1,Pos(' ', s1)-1));
           If S1 = 'Delay' Then Val(S2, SDelay, code);
           If S1 = 'Line' Then Val(S2, SNum, code);
           If S1 = 'Xonix' Then Val(S2, SXon, code);
     End;
     Close (F);

End;

Procedure EGADRV; External;
{$L EGA.OBJ}

begin
     ReadIniFile;
     Randomize;
     If RegisterBGIDriver (@EGADRV) < 0 Then
     Begin
          WriteLn('訡  ॣ樨 ࠩ');
          Halt;
     End;
     grMode:=EGA;
     grDriver := EGALo;
     InitGraph(grDriver,grMode,'c:\tp\bgi\');

     For I:=1 To SXon Do Begin
         P[I].N:=SNum;
         P[I].Let;
         P[I].Fly.StepY := Trunc(Random(5))+2;
         P[I].Fly.StepX := Trunc(Random(5))+2;
         P[I].Draw;
     End;

     repeat
           Delay (SDelay);
           For I:=1 To SXon Do Begin
               P[I].Move;
           End;
     until KeyPressed;

     For I:=1 To SXon Do Begin
         P[I].Hide;
     End;

     CloseGraph;
     Readln;
End.